<html>
  <head>
    <title>Nonogramme Vue.js</title>
    <style>
      table {
        border: 1px solid gray;
        border-collapse: collapse;
      }
      tr, td {
        height: 20px;
      }
      td {
        width: 20px;
        border: 1px solid gray;
      }
      td:hover {
        background-color: red;
      }
      .selected {
        background-color: blue;
      }
    </style>
  </head>
  <body>
    <div id='n7-nonogramme-vuejs'>

      <div>
        Configuration du Nonogramme
        <br/>

        <label>Nombre de colonnes</label>
        <input v-model.number="numberCells" type="number" />
        
        <label>Nombre de lignes</label>
        <input v-model.number="numberRows" type="number" />
        
        <button @click="createCellsValuesArray">Créer le nonogramme</button>
      </div>
      
      <table>
        <tr
          v-for="(currentRow, rowIndex) in cellsValues"
          :key="'r' + rowIndex"
        >
          <td
            v-for="(isCurrentCellSelected, cellIndex) in currentRow"
            :key="'r' + rowIndex + 'c' + cellIndex"
            :class="isCurrentCellSelected ? 'selected' : ''"
            @click="currentRow[cellIndex] = !currentRow[cellIndex]"
          />
        </tr>
      </table>
    </div>
    <script src="https://unpkg.com/vue@next"></script>
    <script type="text/javascript">
      
      function makeCellsValuesArray(numberRows, numberCells) {
        const cellsValues = []
        for (let i = 0; i < numberRows; i++) {
          const currentRowCellsValues = new Array(numberCells).fill(false, 0, numberCells)
          cellsValues.push(currentRowCellsValues)
        }
        return cellsValues
      }
      
      const app = Vue.createApp({
        data() {
          const numberRows = 6
          const numberCells = 6

          return {
            numberRows,
            numberCells,
            cellsValues: makeCellsValuesArray(numberRows, numberCells)
          }
        },
        methods: {
          createCellsValuesArray() {
            this.cellsValues = makeCellsValuesArray(this.numberRows, this.numberCells)
          }
        },
        created () {
          this.numberCells = 10
          this.createCellsValuesArray()
        }
      }).mount('#n7-nonogramme-vuejs')
    </script>
  </body>
</html>
